<?php
defined('IN_COPPERMINE') or die('Not in Coppermine...');

error_reporting(-1);

$thisplugin->add_filter('picture_url','hidemypics_url');
function hidemypics_url ($prow)
{
	global $CONFIG, $superCage;
	static $hmp = null;

	if (isset($prow['system_icon']) || substr($prow['url'],0,7)=='images/') return $prow;

	if (!$hmp) {
		require_once 'plugins/hidemypics/hmpsa.php';
		require 'plugins/hidemypics/cfg.php';
		$hmp = new HideMyPics($hmp_cfg);
	}

	$fsize = isset($prow['filesize']) ? $prow['filesize'] : filesize($prow['url']);
	$encurl = $hmp->enCrypt(json_encode(array($prow['mime'], $fsize, $prow['url'], time())));

	$prow['url'] = $CONFIG['ecards_more_pic_target'] . 'plugins/hidemypics/hmpsa.php?mhf='. urlencode($encurl);

	return $prow;
}

if (!empty($CONFIG['hidemypics_nrc'])) {
	$thisplugin->add_filter('page_meta','hidemypics_nrc');
	$thisplugin->add_filter('fullsize_html','hidemypics_fsh');
}

function hidemypics_nrcs ()
{
	return <<<EOT
<script> 
	document.addEventListener("contextmenu", function(e) { if (e.target.nodeName === "IMG") { e.preventDefault(); } }, false);
</script>
EOT;
}

function hidemypics_nrc ($html)
{
	return hidemypics_nrcs().$html;
}

function hidemypics_fsh ($html)
{
	return str_replace('</head>', hidemypics_nrcs().'</head>', $html);
}


/*** INSTALL/UNINSTALL ***/

$thisplugin->add_action('plugin_install','hidemypics_install');
function hidemypics_install ()
{
	global $CONFIG, $thisplugin;

	if (isset($CONFIG['hidemypics_cfg'])) return true;
	$cfg = array('secr'=>bin2hex(random_bytes(13)),'timo'=>5);

	$cfc = '<?php'."\n".'$hmp_cfg = \''.json_encode($cfg)."';\n";
	file_put_contents(dirname(__FILE__).'/cfg.php', $cfc);

	cpg_config_set('hidemypics_nrc', 1, true);

	return true;
}

$thisplugin->add_action('plugin_uninstall','hidemypics_uninstall');
function hidemypics_uninstall ()
{
	global $CONFIG;
	cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name LIKE 'hidemypics_%'");
	return true;
}
